unit Vraag1_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, pngimage, Math;

type
  TfrmVraag1 = class(TForm)
    pnlOpskrif: TPanel;
    gpbVraag11: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edtNaam: TEdit;
    edtIDNommer: TEdit;
    Label3: TLabel;
    btnVraag11: TButton;
    gpbVraag12: TGroupBox;
    Label4: TLabel;
    lblAfslag: TLabel;
    lblDonasie: TLabel;
    imgAfslag: TImage;
    imgDonasie: TImage;
    gpbVraag13: TGroupBox;
    Label7: TLabel;
    edtBedrag: TEdit;
    edtVertoon: TEdit;
    btnVraag13: TButton;
    gpbVraag14: TGroupBox;
    ckbBesigheid: TCheckBox;
    Label9: TLabel;
    edtDeel1: TEdit;
    Label10: TLabel;
    edtDeel2: TEdit;
    Label11: TLabel;
    edtDeel3: TEdit;
    btnVraag14: TButton;
    lblWelkomboodskap: TLabel;
    Label5: TLabel;
    procedure btnVraag11Click(Sender: TObject);
    procedure imgAfslagClick(Sender: TObject);
    procedure imgDonasieClick(Sender: TObject);
    procedure btnVraag13Click(Sender: TObject);
    procedure btnVraag14Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  sNaam, sIDNommer: string;
  frmVraag1 : TfrmVraag1;
  tipeKaart : string; // voorsien
  karakString: string = '!@#$%]&*^~'; // voorsien

implementation

{$R *.dfm}

procedure TfrmVraag1.btnVraag11Click(Sender: TObject);
var
  bGeenSpasie, bGeenID, bIDLen: boolean;
begin
  // Vraag 1.1
  sNaam := edtNaam.Text;
  bGeenSpasie := pos(' ', sNaam) = 0;
  if bGeenSpasie then
    showMessage('Die naam-en-van-veld bevat nie ''n spasie nie.');
  sIdNommer := edtIDNommer.Text;
  bGeenID := length(sIDNommer) = 0;
  bIDLen := length(sIDNommer) <> 13;
  if bGeenID then
    showMessage('''n IDnommer moet ingesleutel word.')
  else
    if bIDLen then
      showMessage('Die IDnommer bestaan nie uit 13 syfers nie.');

  if (bGeenSpasie = false) AND (bGeenID = false) AND (bIDLen = false) then
    lblWelkomBoodskap.visible := true;
end;

procedure TfrmVraag1.imgDonasieClick(Sender: TObject);
begin
  // Vraag 1.2
  lblDonasie.Font.Style := [fsBold];
  lblAfslag.Font.Style := [];
  tipeKaart := 'LI';
end;

procedure TfrmVraag1.imgAfslagClick(Sender: TObject);
begin
  // Vraag 1.2
  lblAfslag.Font.Style := [fsBold];
  lblDonasie.Font.Style := [];
  tipeKaart := 'AF'
end;

procedure TfrmVraag1.btnVraag13Click(Sender: TObject);
var
  rAfslag, rDonasie: real;
begin
  // Vraag 1.3
  if tipeKaart = 'AF' then
  begin
    rAfslag := 1.5 / 100 * StrToFloat(edtBedrag.Text);
    edtVertoon.Text := '1.5% afslag op jou aankoopbedrag is ' + FloatToStrF
      (rAfslag, ffCurrency, 6, 2) + '.';
  end
  else
  begin
    rDonasie := Math.Ceil(StrToFloat(edtBedrag.Text) / 100) * 3;
    edtVertoon.Text := '''n Bedrag van ' + FloatToStrF(rDonasie, ffCurrency, 6,
      2) + ' sal aan liefdadigheid geskenk word.';
  end
end;

procedure TfrmVraag1.btnVraag14Click(Sender: TObject);
var
  sSimbool: string;
  iPosisie: integer;
  bKaart  : char;
begin
  // Vraag 1.4
  if ckbBesigheid.Checked then
    bKaart := 'B'
  else
    bKaart := 'P';
  iPosisie := StrToInt(sIDNommer[length(sIDNommer)]);
  sSimbool := karakString[iPosisie + 1];
  edtDeel1.Text := bKaart + copy(sIDNommer, 1, 3);
  edtDeel2.Text := IntToStr(iPosisie) + sSimbool;
  edtDeel3.Text := tipeKaart;
end;

procedure TfrmVraag1.FormActivate(Sender: TObject);
begin
  CurrencyString := 'R';
end;

end.
