unit Vraag2_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, KaartHouer_U;

type
  TfrmVraag2 = class(TForm)
    Panel1: TPanel;
    gbpVraag2_1: TGroupBox;
    gpbVraag2_2: TGroupBox;
    Label1: TLabel;
    lblKaartNommer: TLabel;
    cmbKaartnommers: TComboBox;
    Panel2: TPanel;
    Label2: TLabel;
    lblLojaliteitsPunte: TLabel;
    lblSelNommer: TLabel;
    Panel3: TPanel;
    Label3: TLabel;
    edtKode: TEdit;
    btnVraag221: TButton;
    redAfvoer: TRichEdit;
    btnVraag222: TButton;
    procedure cmbKaartnommersChange(Sender: TObject);
    procedure btnVraag221Click(Sender: TObject);
    procedure btnVraag222Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraag2: TfrmVraag2;
  objKaartHouer: TKaartHouer; // Voorsien
  myLeer: Textfile;

implementation

{$R *.dfm}

procedure TfrmVraag2.btnVraag221Click(Sender: TObject);
var
  sKaartHouer: string;
  sSelNommer: string;
  sLojaliteitsPunte: string;
  sToegang: string;
  sReelEen, sReelTwee, sReelDrie: string;
  rTotaalSpandeer, rTotaalGesond: real;
  iBesoeke: integer;
begin
  sKaartHouer := cmbKaartNommers.items[cmbKaartNommers.ItemIndex];
  sSelNommer := lblSelNommer.Caption;
  sLojaliteitsPunte := lblLojaliteitsPunte.Caption;

  objKaartHouer := TKaartHouer.create(sKaartHouer, sSelNommer,
    StrToInt(sLojaliteitsPunte));
  sToegang := edtKode.Text;
  if objKaartHouer.isReg(sToegang) then
  begin
    showMessage('Die toegangskode is reg. ');
    rTotaalSpandeer := 0;
    rTotaalGesond := 0;
    iBesoeke := 0;
    assignFile(myLeer, 'DataJanuarie2017.txt');
    reset(myLeer);
    while not eof(myLeer) do
     begin
      readln(myLeer, sReelEen);
      readln(myLeer, sReelTwee);
      readln(myLeer, sReelDrie);
      if sReelEen = sKaartHouer then
       begin
        rTotaalSpandeer := rTotaalSpandeer + StrToFloat(sReelTwee);
        rTotaalGesond := rTotaalGesond + StrToFloat(sReelDrie);
        inc(iBesoeke);
       end; // end if
     end; // end while
    closeFile(myLeer);

    objKaartHouer.vermeerderLojaliteitsPunte(rTotaalSpandeer);
    objKaartHouer.setAantBesoeke(iBesoeke);
    objKaartHouer.opdateerGesondVlak(rTotaalGesond, rTotaalSpandeer);
    btnVraag222.Enabled := true;
  end // end isReg
  else
  begin
    showMessage('Verkeerde toegangskode.');
    edtKode.Clear;
  end;
end;

procedure TfrmVraag2.btnVraag222Click(Sender: TObject);
begin
  redAfvoer.Clear;
  redAfvoer.Lines.Add(objKaartHouer.toString);
  redAfvoer.Lines.Add(objKaartHouer.identifiseerSterKoper);
end;

// Kode wat voorsien is
procedure TfrmVraag2.cmbKaartnommersChange(Sender: TObject);
begin
  edtKode.Clear;
  redAfvoer.Clear;
  btnVraag222.Enabled := false;
  case cmbKaartNommers.ItemIndex of
    0:
      begin
        lblLojaliteitsPunte.Caption := '2130';
        lblSelNommer.Caption := '0812345678';
      end;

    1:
      begin
        lblLojaliteitsPunte.Caption := '5723';
        lblSelNommer.Caption := '0822001100';
      end;

    2:
      begin
        lblLojaliteitsPunte.Caption := '12908';
        lblSelNommer.Caption := '0740998877';
      end;

    3:
      begin
        lblLojaliteitsPunte.Caption := '500';
        lblSelNommer.Caption := '0720951083';
      end;
  end;

end;

end.
